unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}
uses OpenGL;
//      
Const
  AngleDl=5;
//  
var
  hrc: HGLRC;
  dc: HDC;
  //       
  AngleX, AngleY, AngleZ: integer;

procedure TForm1.FormCreate(Sender: TObject);
var PFD: TPixelFormatDescriptor;
  i: integer;
begin
  //        GetDC
  dc:=GetDC(handle);
  //   pfd
  FillChar(PFD, SizeOf(PFD),0);
  pfd.dwFlags  := PFD_DRAW_TO_WINDOW
    or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
  //        
  i:=ChoosePixelFormat(dc, @PFD);
  if i=0 then
    raise Exception.Create('    !');
  //      ,   
  // -  ChoosePixelFormat
  if not SetPixelFormat(dc, i, @PFD) then
    raise Exception.Create('     !');
  //      OpenGL
  //         
  hrc:=wglCreateContext(dc);
  if hrc=0 then
    raise Exception.Create('    !');
  //    
  if not wglMakeCurrent(dc, hrc) then
    raise
      Exception.Create('     !');
  glEnable(GL_DEPTH_TEST);

  AngleX := 30;
  AngleY := 30;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if not wglMakeCurrent(0, 0) then
    raise Exception.Create(
      '     !');
  if not wglDeleteContext(hrc) then
    raise Exception.Create('    !');
  if ReleaseDC(Form1.Handle, dc)=0 then
    raise Exception.Create('   ');
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_INSERT: inc(AngleX, AngleDl);
    VK_DELETE: dec(AngleX, AngleDl);
    VK_HOME: inc(AngleY, AngleDl);
    VK_END: dec(AngleY, AngleDl);
    VK_PRIOR: inc(AngleZ, AngleDl);
    VK_NEXT: dec(AngleZ, AngleDl);
  end;
  //     
  InvalidateRect(Handle, nil, False);
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  n: Double;
begin
  glClearColor (1, 1, 1, 1); //  
  glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  //      
  glMatrixMode(GL_MODELVIEW);
  //  
  glLoadIdentity;
  glRotatef(AngleX, 1.0, 0.0, 0.0);
  glRotatef(AngleY, 0.0, 1.0, 0.0);
  glRotatef(AngleZ, 0.0, 0.0, 1.0);

  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);

  n := 0.5; //    

  glColor3f(1, 0, 0);
  glBegin (GL_QUADS);
    glNormal3f(0, 0, 1);
    glVertex3f (0.5, 0.5, 0.5);
    glVertex3f (-0.5, 0.5, 0.5);
    glVertex3f (-0.5, -0.5, 0.5);
    glVertex3f (0.5, -0.5, 0.5);
  glEnd;


  glColor3f(0, 1, 0);
  glBegin (GL_QUADS);
    glNormal3f(0, 0, -1);
    glVertex3f (0.5, 0.5, -0.5);
    glVertex3f (0.5, -0.5, -0.5);
    glVertex3f (-0.5, -0.5, -0.5);
    glVertex3f (-0.5, 0.5, -0.5);
  glEnd;


  glColor3f(0, 0, 1);
  glBegin (GL_QUADS);
    glNormal3f(-1, 0, 0);
    glVertex3f (-0.5, 0.5, 0.5);
    glVertex3f (-0.5, 0.5, -0.5);
    glVertex3f (-0.5, -0.5, -0.5);
    glVertex3f (-0.5, -0.5, 0.5);
  glEnd;

  glDisable(GL_LIGHTING);

  //   

  glFlush;
  glFinish;
  SwapBuffers(DC);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  //   
  glViewPort (0, 0, ClientWidth, ClientHeight);
  //   
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(-1, 1, -1, 1, -1, 1);
  glMatrixMode(GL_MODELVIEW);
  //  
  InvalidateRect(Handle, nil, False);
end;

end.
